import { line, curve, curveCardinal } from 'd3';

export const Marks = ({
  yScale,
  xScale,
  data,
  xValue,
  yValue,
  tooltipFormat,
  circleRadius,
}) => (
  <g className="marks">
    <path
      fill="none"
      d={line()
        .x((d) => xScale(d.timestamp))
        .y((d) => yScale(d.temperature))
        .curve(curveCardinal)(data)}
    />
    {data.map((d) => (
      <circle
        cx={xScale(xValue(d))}
        cy={yScale(yValue(d))}
        r={circleRadius}
      >
        <title>{`${tooltipFormat(xValue(d))}, ${d.timestamp.toLocaleString('default', { month: 'long' })}, ${parseFloat(d.temperature).toFixed(1)} C`}</title>
      </circle>
    ))}
  </g>
);
